﻿Imports System.Net.Sockets
Public Class Form1

#Region " Read Me "
    ''
    '' Winsock 서버 예제 소스
    '' 본 소스는 Winsock을 이용한 다중 소캣 서버 예제 소스 입니다.
    ''
    '' 기존 VB6 'Microsoft Winsock Control'과 비슷한 메서드, 이벤트를 가지고 있습니다.
    ''
    '' * 기본 사용 방법
    ''
    '' 1. Winsock_Control.vb를 프로젝트에 추가 합니다.
    '' 2. 선언을 통해 컨트롤을 생성합니다. 클래스 명은 'Winsock' 입니다. (ex - Dim Socket As New Winsock)
    '' 3. 아래 예제를 통해 사용법을 익힌 후 사용합니다.
    ''
    '' * 참고 사항
    '' 
    '' 1. 디버그 모드를 사용할 수 있습니다.
    '' Debug 모드 사용시 모든 오류가 'HandleEvents' 이벤트로 통해 발생되지 않고, 런타임 오류가 발생됩니다.
    '' 
    '' 디버그 모드 사용 방법 : Socket.DEBUG_MODE = True
    ''
    '' 
    ''
    ''
    '' Made By - 프매씨 (ruddbs5301@naver.com/http://vmao.tistory.com)
    '' (2015-1-18 최종 수정)
#End Region
    Dim WithEvents Server_Socket As New Winsock '//연결 요청을 받는 역할
    Dim Client_Stack() As Winsock '//연결 요청이 오는 클라이언트와 직접 연결되는 소캣

    '' 배열을 통해 Winsock 컨트롤을 이용할 경우 선언과 동시에 컨트롤 생성을 진행하면 컴파일 오류가 발생됩니다.
    '' (해당 이유를 아시는 분은 위에 적힌 이메일로 알려주세요...)
    ''
    '' ex) Dim Client_Stack() As New Winsock <<- 이와 같이 하면 컴파일 오류가 발생.

    Private Const Server_Port As Integer = 9999 '//서버 포트
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load


        '//서버 소캣 리스닝
        Server_Socket.LocalPort = Server_Port
        Server_Socket.Listen()

        Server_Socket.DEBUG_MODE = True '//DEBUG_MODE를 사용합니다.

        '//클라이언트 소캣 초기화
        ReDim Client_Stack(0)

        Client_Stack(0) = New Winsock '//클라이언트 소캣 컨트롤 생성

    End Sub
    Delegate Sub Update_Invoke(ByVal Str As String)
    Private Sub Updates_List(Str As String)

        If ListBox1.InvokeRequired Then
            ListBox1.Invoke(New Update_Invoke(AddressOf Updates_List), New Object() {Str})
        Else
            ListBox1.Items.Add(Str)
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1
        End If

    End Sub
    Private Sub Updates_Label(value As String)

        If Label2.InvokeRequired Then
            Label2.Invoke(New Update_Invoke(AddressOf Updates_Label), New Object() {value})
        Else
            Label2.Text = Val(Label2.Text) + Val(value)
        End If

    End Sub

    Private Sub Server_Socket_ConnectionRequest(sender As Winsock, requestID As Socket) Handles Server_Socket.ConnectionRequest
        '//서버에 클라이언트가 연결 요청시 발생하는 이벤트

        Dim i As Long

        '//소캣이 열려 있는 클라이언트 소캣을 찾는다.
        For i = 0 To UBound(Client_Stack)

            '//열려있는 소캣을 찾은 경우
            If (Client_Stack(i).GetState = WinsockStates.Closed) Then

                '//이벤트 핸들러 생성
                AddHandler Client_Stack(0).Connected, AddressOf Client_Connected
                AddHandler Client_Stack(i).Disconnected, AddressOf Client_Disconnected
                AddHandler Client_Stack(i).DataArrival, AddressOf Client_DataArrival
                AddHandler Client_Stack(i).SendComplete, AddressOf Client_SendComplete
                AddHandler Client_Stack(i).StateChanged, AddressOf Client_StateChanged
                AddHandler Client_Stack(i).HandleError, AddressOf Client_HandleError

                '//해당 소캣으로 연결을 해준다.
                Client_Stack(i).Accept(requestID)

                '//리스트 업데이트
                Me.Updates_List("<< rev - Accept Connect" & Client_Stack(i).Index & "/" & Client_Stack.GetHashCode)
                Me.Updates_Label(1)
                Exit Sub

            End If

        Next

        '//빈 소캣이 없을 경우 

        i = UBound(Client_Stack) + 1

        '//재선언으로 컨트롤 배열을 확장
        ReDim Preserve Client_Stack(i)

        Client_Stack(i) = New Winsock  '//컨트롤 생성

        '//이벤트 핸들러 생성
        AddHandler Client_Stack(i).Connected, AddressOf Client_Connected
        AddHandler Client_Stack(i).Disconnected, AddressOf Client_Disconnected
        AddHandler Client_Stack(i).DataArrival, AddressOf Client_DataArrival
        AddHandler Client_Stack(i).SendComplete, AddressOf Client_SendComplete
        AddHandler Client_Stack(i).StateChanged, AddressOf Client_StateChanged
        AddHandler Client_Stack(i).HandleError, AddressOf Client_HandleError

        Client_Stack(i).Accept(requestID) '//해당 소캣으로 연결을 해준다.

        '//리스트 업데이트
        Me.Updates_List("<< rev - Accept Connect" & Client_Stack(i).Index & "/" & Client_Stack.GetHashCode)
        Me.Updates_Label(1)

    End Sub

    Private Sub Client_Connected(sender As Winsock)
        '//클라이언트 소캣이 연결 됬을 경우

        Debug.Print(sender.Index & "연결 됨")


    End Sub

    Private Sub Client_DataArrival(sender As Winsock, BytesTotal As Integer, Data As Byte())
        '//클라이언트 소캣에 데이터가 도착했을 경우
        Dim Data_Temp As String
        Data_Temp = sender.GetDataString()

        '//다음과 같은 방법도 있습니다.
        'sender.GetData -> Byte() 반환
        'sender.GetData(Bitmaps) Bitmaps 변수에 Bitmap 형 값을 대입(상대가 Bitmap 관련 데이터를 보낼 경우 사용 권장)
        'sender.GetData(Strings) Strings 변수에 String 형 값을 대입
        'sender.GetData(Bytes) Bytes 변수에 Bytes() 형 값을 대입

        Debug.Print(sender.Index & "/" & Data_Temp)
        Updates_List("<< rev - Get Data " & sender.Index & "/" & Data_Temp)
    End Sub

    Private Sub Client_Disconnected(sender As Winsock)
        '//클라이언트로 부터 연결이 끊겼을 경우
        '//소캣 구분은 기본적으로 'sender.index'로 확인합니다.

        Debug.Print(sender.Index & "연결 끊김")
        Updates_List("<< rev - Disconnected N." & sender.Index)
        Updates_Label(-1)

        sender = Nothing '//메모리 확보를 위해 컨트롤 삭제

    End Sub

    Private Sub Client_HandleError(sender As Winsock, Description As String, Method As String, myEx As String)
        '//클라이언트 소캣에서 오류가 발생할 경우
        '//소캣 구분은 기본적으로 'sender.index'로 확인합니다.

        Updates_List("-- error - " & Description & "/" & Method & "/" & myEx)
        Debug.Print(Description & "/" & Method & "/" & myEx)

    End Sub

    Private Sub Client_SendComplete(sender As Winsock)
        '//클라이언트로 데이터 전송을 성공할 경우
        '//소캣 구분은 기본적으로 'sender.index'로 확인합니다.

        Updates_List(">> send - Send Succecs")

    End Sub

    Private Sub Client_StateChanged(sender As Winsock, state As WinsockStates)
        '//클라이언트 상태가 변경 될 경우
        '//소캣 구분은 기본적으로 'sender.index'로 확인합니다.

        '//상태 관련은 'Winsock_Control.WinsockStates' 을 참조해주세요.
        Updates_List("-- state_chg - N." & sender.Index & " / " & state.ToString)

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim index_temp As Integer = Int(TextBox2.Text)
        Dim data_temp As String = TextBox1.Text.ToString


        If UBound(Client_Stack) < index_temp Then

            Updates_List("-- error - N." & index_temp & " not connected")

            '//소캣의 상태는 'GetState'로 알아낼 수 있습니다.
            '//상태 관련은 'Winsock_Control.WinsockStates' 을 참조해주세요.
        ElseIf Client_Stack(index_temp).GetState = WinsockStates.Connected Then

            Updates_List(">> send - N." & index_temp & " / " & data_temp)

            '//Socket.Send 메서드는 기본적으로 Byte(), String, Bitmap 형을 전송할 수 있습니다.
            '//최종적으로 Byte() 형으로 전송됩니다.
            Client_Stack(index_temp).Send(data_temp)

        Else

            Updates_List("-- error - N." & index_temp & " not connected")

        End If

    End Sub
End Class
